## dde-cooperation 1.0.2

=== CMakeLists.txt ===
﻿cmake_minimum_required(VERSION 3.13)

project(dde-cooperation VERSION 0.1 LANGUAGES CXX)

set(CMAKE_INCLUDE_CURRENT_DIR ON)


set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)


if (NOT WIN32)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -fPIE")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--as-need")

    #安全加固
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror=return-type")

    #安全加固
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all")
    if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -z noexecstack -z relro")
        add_definitions(-D ARCH_MIPSEL)
    endif()
endif()

if(WIN32)
    # windows7 support
    add_definitions(-D_WIN32_WINNT=0x0601)

    # windeployqt 依赖
    include (cmake/qt-helper.cmake)

    # windows 并行编译选项
    cmake_host_system_information(RESULT CPU_NUMBER_OF_LOGICAL_CORES QUERY NUMBER_OF_LOGICAL_CORES)
    add_compile_options($<$<CXX_COMPILER_ID:MSVC>:/MP${CPU_NUMBER_OF_LOGICAL_CORES}>)
endif()

include(GNUInstallDirs)

option(FPIC "build with -fPIC" FALSE)

if(MSVC)
    add_compile_options(/fp:fast /EHsc)
    add_link_options(/SAFESEH:NO)
    if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
        string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
    else()
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
    endif()
else()
    add_compile_options(-Wall -O2 -g -Wno-sign-compare -Wno-strict-aliasing)
    set(FPIC TRUE)
endif()

if(NOT DEFINED LIB_INSTALL_DIR)
    set(LIB_INSTALL_DIR ${CMAKE_INSTALL_FULL_LIBDIR})
endif()

include (cmake/version.cmake)

message("   >>> LIB_INSTALL_DIR  ${LIB_INSTALL_DIR}")
message("   >>> COMPILE ON SYSTEM: ${CMAKE_SYSTEM}")

include_directories(include)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

if (WIN32)
    set(DEPLOY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/output")
    message("   >>> DEPLOY_OUTPUT_DIRECTORY  ${DEPLOY_OUTPUT_DIRECTORY}")

    # windows runtime output defined
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${DEPLOY_OUTPUT_DIRECTORY})
#    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${DEPLOY_OUTPUT_DIRECTORY})
#    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${DEPLOY_OUTPUT_DIRECTORY})

    file(GLOB INNO_SCRIPTS ${CMAKE_CURRENT_SOURCE_DIR}/dist/inno/scripts)
    file(COPY ${INNO_SCRIPTS} DESTINATION ${CMAKE_BINARY_DIR})
endif()

# 如果未设置CMAKE_BUILD_TYPE，则将其设置为Release
message("   >>> CMAKE_BUILD_TYPE  ${CMAKE_BUILD_TYPE}")
if(NOT CMAKE_BUILD_TYPE)
   message("Cmake build type is not defined!")
   set(CMAKE_BUILD_TYPE "Debug")
endif()

# 后台进程安装目录
if(CMAKE_SYSTEM_NAME STREQUAL "Windows")
  set(EXECUTABLE_INSTALL_DIR "")
else()
  set(EXECUTABLE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/libexec/${PROJECT_NAME}")
endif()

# Find Qt version
find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
# 检查并设置环境变量
if(NOT DEFINED ENV{QT_SELECT})
    set(ENV{QT_SELECT} "qt${QT_VERSION_MAJOR}")
endif()
message("   >>> Build with Qt version: $ENV{QT_SELECT}")

if (QT_VERSION_MAJOR EQUAL "6")
    set(DTK_VERSION_MAJOR 6)
else()
    set(DTK_VERSION_MAJOR "")
endif()

# 引入翻译生成
include(translation-generate)

# header-only libraries: jwt, picojson
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/include)

# Modules
add_subdirectory("modules")

if(MSVC)
    add_compile_options(/utf-8)
endif()
add_subdirectory(src)

=== modules/CMakeLists.txt ===
include("cppserver.cmake")
include("barrier.cmake")
include("sslconf.cmake")
include("quazip.cmake")
include("QtZeroConf.cmake")
include("CuteIPC.cmake")

=== src/CMakeLists.txt ===
# share libraries
add_subdirectory(lib)

add_subdirectory(apps)

# compat v20 daemon app
add_subdirectory(compat)

=== 3rdparty/CppServer/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

# Global properties
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

# Project name
project(cppserver)

# Doxygen
find_package(Doxygen)
if(DOXYGEN_FOUND)
  set(DOXYGEN "doxygen")
  if(NOT TARGET ${DOXYGEN})
    add_custom_command(OUTPUT "Doxyfile" COMMAND ${DOXYGEN_EXECUTABLE} "Doxyfile" WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/documents")
    add_custom_target(${DOXYGEN} DEPENDS "Doxyfile")
    set_target_properties(${DOXYGEN} PROPERTIES FOLDER "doxygen")
  endif()
endif()

# CMake module path
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

# Compiler features
include(SetCompilerFeatures)
if (NOT ANDROID)
include(SetCompilerWarnings)
endif()
include(SetPlatformFeatures)
include(SystemInformation)

# External packages
if(BIND_STATIC_OPENSSL)
  if(APPLE)
    set(OPENSSL_ROOT_DIR "/usr/local/opt/openssl@3")
  elseif(CYGWIN)
    set(OPENSSL_ROOT_DIR "/usr/lib")
    set(OPENSSL_INCLUDE_DIR "/usr/include")
    set(OPENSSL_CRYPTO_LIBRARY "/usr/lib/libcrypto.dll.a")
    set(OPENSSL_SSL_LIBRARY "/usr/lib/libssl.dll.a")
  elseif(MINGW AND NOT MSYS)
    set(OPENSSL_ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/modules/OpenSSL/MinGW")
    set(OPENSSL_USE_STATIC_LIBS TRUE)
  elseif(MSVC)
    set(OPENSSL_ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/modules/OpenSSL/VS")
    set(OPENSSL_USE_STATIC_LIBS TRUE)
    set(OPENSSL_MSVC_STATIC_RT TRUE)
  endif()
endif()

if (ANDROID)
    message("   >>> ANDROID_HOME  $ENV{ANDROID_HOME}")
    
    if (DEFINED ENV{ANDROID_HOME})
      set(ssl_root_path $ENV{ANDROID_HOME}/android_openssl)
      list(APPEND android_extra_libs
         ${ssl_root_path}/ssl_1.1/${CMAKE_ANDROID_ARCH_ABI}/libcrypto_1_1.so
         ${ssl_root_path}/ssl_1.1/${CMAKE_ANDROID_ARCH_ABI}/libssl_1_1.so)

      set(OPENSSL_ROOT_DIR ${ssl_root_path}/ssl_1.1/${CMAKE_ANDROID_ARCH_ABI})
      set(OPENSSL_INCLUDE_DIR ${ssl_root_path}/ssl_1.1/include)
      set(OPENSSL_LIBRARIES ${android_extra_libs})
      set(OPENSSL_VERSION 1.1)
    else()
        message(FATAL_ERROR "ANDROID_HOME环境变量未设置！")
    endif()
else()
    find_package(OpenSSL REQUIRED)
endif()

list(APPEND LINKLIBS ${OPENSSL_LIBRARIES})

if(WIN32)
  find_package(Crypt)
  find_package(WinSock)
endif()

# Modules
add_subdirectory("modules")

# Link libraries
if(WIN32)
  list(APPEND LINKLIBS ${CRYPT_LIBRARIES})
  list(APPEND LINKLIBS ${WINSOCK_LIBRARIES})
endif()
list(APPEND LINKLIBS cppcommon)
if (NOT ANDROID)
  list(APPEND LINKLIBS cpplogging)
endif()

# OpenSSL libraries
message(STATUS "OpenSSL version: ${OPENSSL_VERSION} ${OPENSSL_INCLUDE_DIR} ${OPENSSL_LIBRARIES}")

# System directories
include_directories(SYSTEM "${CMAKE_CURRENT_SOURCE_DIR}/modules")

# Library
file(GLOB_RECURSE LIB_HEADER_FILES "include/*.h" "source/*.h")
file(GLOB_RECURSE LIB_INLINE_FILES "include/*.inl" "source/*.inl")
file(GLOB_RECURSE LIB_SOURCE_FILES "include/*.cpp" "source/*.cpp")
add_library(cppserver STATIC ${LIB_HEADER_FILES} ${LIB_INLINE_FILES} ${LIB_SOURCE_FILES})
set_target_properties(cppserver PROPERTIES COMPILE_FLAGS "${PEDANTIC_COMPILE_FLAGS}" FOLDER "libraries")
target_include_directories(cppserver PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/include")
target_link_libraries(cppserver ${LINKLIBS} asio)
list(APPEND INSTALL_TARGETS cppserver)
list(APPEND LINKLIBS cppserver)

if(FPIC)
  set_target_properties(cppserver PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif()

if(BUILD_SHARED_LIBS)
    set_target_properties(cppserver PROPERTIES CXX_VISIBILITY_PRESET hidden VISIBILITY_INLINES_HIDDEN ON)
endif()

# Additional module components: benchmarks, examples, plugins, tests, tools and install
if(NOT CPPSERVER_MODULE)

  # Proto library
  file(GLOB_RECURSE PROTO_HEADER_FILES "proto/*.h")
  file(GLOB_RECURSE PROTO_INLINE_FILES "proto/*.inl")
  file(GLOB_RECURSE PROTO_SOURCE_FILES "proto/*.cpp")
  add_library(proto ${PROTO_HEADER_FILES} ${PROTO_INLINE_FILES} ${PROTO_SOURCE_FILES})
  set_target_properties(proto PROPERTIES COMPILE_FLAGS "${PEDANTIC_COMPILE_FLAGS}" FOLDER "proto")
  target_include_directories(proto PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/proto")
  target_link_libraries(proto ${LINKLIBS})
  list(APPEND INSTALL_TARGETS proto)
  list(APPEND LINKLIBS proto)

  # Examples
  file(GLOB EXAMPLE_HEADER_FILES "examples/*.h")
  file(GLOB EXAMPLE_INLINE_FILES "examples/*.inl")
  file(GLOB EXAMPLE_SOURCE_FILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}/examples" "examples/*.cpp")
  foreach(EXAMPLE_SOURCE_FILE ${EXAMPLE_SOURCE_FILES})
    string(REGEX REPLACE "(.*)\\.cpp" "\\1" EXAMPLE_NAME ${EXAMPLE_SOURCE_FILE})
    set(EXAMPLE_TARGET "cppserver-example-${EXAMPLE_NAME}")
    add_executable(${EXAMPLE_TARGET} ${EXAMPLE_HEADER_FILES} ${EXAMPLE_INLINE_FILES} "examples/${EXAMPLE_SOURCE_FILE}")
    set_target_properties(${EXAMPLE_TARGET} PROPERTIES COMPILE_FLAGS "${PEDANTIC_COMPILE_FLAGS}" FOLDER "examples")
    target_link_libraries(${EXAMPLE_TARGET} ${LINKLIBS})
    list(APPEND INSTALL_TARGETS ${EXAMPLE_TARGET})
    list(APPEND INSTALL_TARGETS_PDB ${EXAMPLE_TARGET})
  endforeach()

  # Benchmarks
  file(GLOB BENCHMARK_HEADER_FILES "performance/*.h")
  file(GLOB BENCHMARK_INLINE_FILES "performance/*.inl")
  file(GLOB BENCHMARK_SOURCE_FILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}/performance" "performance/*.cpp")
  foreach(BENCHMARK_SOURCE_FILE ${BENCHMARK_SOURCE_FILES})
    string(REGEX REPLACE "(.*)\\.cpp" "\\1" BENCHMARK_NAME ${BENCHMARK_SOURCE_FILE})
    set(BENCHMARK_TARGET "cppserver-performance-${BENCHMARK_NAME}")
    add_executable(${BENCHMARK_TARGET} ${BENCHMARK_HEADER_FILES} ${BENCHMARK_INLINE_FILES} "performance/${BENCHMARK_SOURCE_FILE}")
    set_target_properties(${BENCHMARK_TARGET} PROPERTIES COMPILE_FLAGS "${PEDANTIC_COMPILE_FLAGS}" FOLDER "performance")
    target_link_libraries(${BENCHMARK_TARGET} ${LINKLIBS} cppbenchmark)
    list(APPEND INSTALL_TARGETS ${BENCHMARK_TARGET})
    list(APPEND INSTALL_TARGETS_PDB ${BENCHMARK_TARGET})
  endforeach()

  # Tests
  file(GLOB TESTS_HEADER_FILES "tests/*.h")
  file(GLOB TESTS_INLINE_FILES "tests/*.inl")
  file(GLOB TESTS_SOURCE_FILES "tests/*.cpp")
  add_executable(cppserver-tests ${TESTS_HEADER_FILES} ${TESTS_INLINE_FILES} ${TESTS_SOURCE_FILES})
  set_target_properties(cppserver-tests PROPERTIES COMPILE_FLAGS "${PEDANTIC_COMPILE_FLAGS}" FOLDER "tests")
  target_include_directories(cppserver-tests PRIVATE Catch2)
  target_link_libraries(cppserver-tests ${LINKLIBS} Catch2)
  list(APPEND INSTALL_TARGETS cppserver-tests)
  list(APPEND INSTALL_TARGETS_PDB cppserver-tests)

  # CTest
  enable_testing()
  add_test(cppserver-tests cppserver-tests --durations yes --order lex)

  # Install
  install(TARGETS ${INSTALL_TARGETS}
    RUNTIME DESTINATION "${PROJECT_SOURCE_DIR}/bin"
    LIBRARY DESTINATION "${PROJECT_SOURCE_DIR}/bin"
    ARCHIVE DESTINATION "${PROJECT_SOURCE_DIR}/bin")

  # Install *.pdb files
  if(MSVC)
    foreach(INSTALL_TARGET_PDB ${INSTALL_TARGETS_PDB})
      install(FILES $<TARGET_PDB_FILE:${INSTALL_TARGET_PDB}> DESTINATION "${PROJECT_SOURCE_DIR}/bin")
    endforeach()
  endif()

endif()

=== 3rdparty/CuteIPC/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

# Project
PROJECT(CuteIPC VERSION 0.1.0)

ENABLE_TESTING(true)

# CMake module path
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/CMake)

# Compile flags
INCLUDE(CompilerFlags)

# Qt
MESSAGE("Searching for preferred Qt version...")
IF (DEFINED QT_DESIRED_VERSION)
  IF(QT_DESIRED_VERSION MATCHES 5)
    SET(QT_VERSION_MAJOR 5)
    FIND_PACKAGE(Qt5Core REQUIRED)
    FIND_PACKAGE(Qt5Gui REQUIRED)
    FIND_PACKAGE(Qt5Network REQUIRED)
  ELSE (QT_DESIRED_VERSION MATCHES 5)
    IF (QT_DESIRED_VERSION MATCHES 4)
      FIND_PACKAGE(Qt4 COMPONENTS QtCore QtGui QtNetwork REQUIRED)
      INCLUDE(${QT_USE_FILE})
    ELSE (QT_DESIRED_VERSION MATCHES 4)
      MESSAGE(FATAL_ERROR "You must specify the 4th or the 5th version of Qt")
    ENDIF(QT_DESIRED_VERSION MATCHES 4)
  ENDIF (QT_DESIRED_VERSION MATCHES 5)
ELSE (DEFINED QT_DESIRED_VERSION)
  FIND_PACKAGE(Qt5Core QUIET)
  FIND_PACKAGE(Qt5Gui QUIET)
  FIND_PACKAGE(Qt5Network QUIET)
  IF (Qt5Core_FOUND)
    SET(QT_VERSION_MAJOR 5)
  ELSE(Qt5Core_FOUND)
    MESSAGE("Qt 5 not found, searching for Qt4")
    FIND_PACKAGE(Qt4 REQUIRED)
  ENDIF(Qt5Core_FOUND)
ENDIF (DEFINED QT_DESIRED_VERSION)
find_package(QT NAMES Qt6 Qt5 Qt4 REQUIRED COMPONENTS Core Network Gui)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Network Gui)
MESSAGE("Qt version is used: ${QT_VERSION_MAJOR}")

# Include directories
INCLUDE_DIRECTORIES(include src ${CMAKE_CURRENT_BINARY_DIR})

# Turn off automoc
SET(CMAKE_AUTOMOC OFF)

SET(sources
  src/CuteIPCService.cpp
  src/CuteIPCInterface.cpp
  src/CuteIPCMarshaller.cpp
  src/CuteIPCServiceConnection.cpp
  src/CuteIPCInterfaceConnection.cpp
  src/CuteIPCMessage.cpp
  src/CuteIPCSignalHandler.cpp
  src/CuteIPCInterfaceWorker.cpp
)

SET(headers
  include/CuteIPCService.h
  include/CuteIPCInterface.h
  src/CuteIPCService_p.h
  src/CuteIPCInterface_p.h
  src/CuteIPCMarshaller_p.h
  src/CuteIPCMessage_p.h
  src/CuteIPCSignalHandler_p.h
)

SET(moc_headers
  src/CuteIPCServiceConnection_p.h
  src/CuteIPCInterfaceConnection_p.h
  src/CuteIPCInterfaceWorker.h
)

SET(moc_service
  ${CMAKE_CURRENT_BINARY_DIR}/moc_CuteIPCService.cpp
)

SET(moc_interface
  ${CMAKE_CURRENT_BINARY_DIR}/moc_CuteIPCInterface.cpp
)

IF (QT_VERSION_MAJOR MATCHES 6)
  QT6_WRAP_CPP(sources ${moc_headers})
  QT6_GENERATE_MOC(include/CuteIPCService.h ${moc_service})
  QT6_GENERATE_MOC(include/CuteIPCInterface.h ${moc_interface})
ELSEIF (QT_VERSION_MAJOR MATCHES 5)
  QT5_WRAP_CPP(sources ${moc_headers})
  QT5_GENERATE_MOC(include/CuteIPCService.h ${moc_service})
  QT5_GENERATE_MOC(include/CuteIPCInterface.h ${moc_interface})
ELSE()
  QT4_WRAP_CPP(sources ${moc_headers})
  QT4_GENERATE_MOC(include/CuteIPCService.h ${moc_service})
  QT4_GENERATE_MOC(include/CuteIPCInterface.h ${moc_interface})
ENDIF()

SET_SOURCE_FILES_PROPERTIES(src/CuteIPCService.cpp PROPERTIES OBJECT_DEPENDS ${moc_service})
SET_SOURCE_FILES_PROPERTIES(src/CuteIPCInterface.cpp PROPERTIES OBJECT_DEPENDS ${moc_interface})

add_library(${PROJECT_NAME} ${sources} ${headers} ${moc_headers})

if(BUILD_SHARED_LIBS)
    target_compile_definitions(${PROJECT_NAME} PRIVATE QT_BUILD_SHARED)
    set_target_properties(${PROJECT_NAME} PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION 0)
    set_target_properties(${PROJECT_NAME} PROPERTIES CXX_VISIBILITY_PRESET hidden VISIBILITY_INLINES_HIDDEN ON)
endif()

if(FPIC)
    set_target_properties(${PROJECT_NAME} PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif()

target_link_libraries(${PROJECT_NAME}
    PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Network
    Qt${QT_VERSION_MAJOR}::Gui
)

TARGET_INCLUDE_DIRECTORIES(${PROJECT_NAME} PUBLIC
  ${CMAKE_CURRENT_SOURCE_DIR}/include
)

SET(CUTEIPC_BUILD_EXAMPLES OFF CACHE BOOL "Build CuteIPC examples")
SET(CUTEIPC_BUILD_TESTS OFF CACHE BOOL "Build CuteIPC tests")


# Examples
IF (CUTEIPC_BUILD_EXAMPLES)
  ADD_SUBDIRECTORY(example/client)
  ADD_SUBDIRECTORY(example/server)
ENDIF ()

IF (CUTEIPC_BUILD_TESTS)
  ADD_SUBDIRECTORY(test)
ENDIF ()

#INSTALL(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
if(WIN32)
    INSTALL(TARGETS ${PROJECT_NAME}
        RUNTIME DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
else()
    INSTALL(TARGETS ${PROJECT_NAME}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
endif()

=== 3rdparty/barrier/CMakeLists.txt ===
# Barrier -- mouse and keyboard sharing utility
# Copyright (C) 2018 Debauchee Open Source Group
# Copyright (C) 2012-2016 Symless Ltd.
# Copyright (C) 2009 Nick Bolton
#
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file LICENSE that should have accompanied this file.
#
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required (VERSION 3.4)
project (barrier C CXX)

option (BARRIER_BUILD_GUI "Build the GUI" OFF)
option (BARRIER_BUILD_INSTALLER "Build the installer" OFF)
option (BARRIER_BUILD_TESTS "Build the tests" OFF)
option (BARRIER_USE_EXTERNAL_GTEST "Use external installation of Google Test framework" OFF)

set (CMAKE_EXPORT_COMPILE_COMMANDS ON)
set (CMAKE_CXX_STANDARD 17)
set (CMAKE_CXX_EXTENSIONS OFF)
set (CMAKE_CXX_STANDARD_REQUIRED ON)
set (CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
set (CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")

if (NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_definitions (-DNDEBUG)
endif()

include (cmake/Version.cmake)
include (cmake/Package.cmake)
include (cmake/FindLibDJK.cmake)

# TODO: Find out why we need these, and remove them
if (COMMAND cmake_policy)
    cmake_policy (SET CMP0003 NEW)
    cmake_policy (SET CMP0005 NEW)
endif()

# Add headers to source list
if (${CMAKE_GENERATOR} STREQUAL "Unix Makefiles")
    set (BARRIER_ADD_HEADERS FALSE)
else()
    set (BARRIER_ADD_HEADERS TRUE)
endif()

set (libs)

if (UNIX)
    if (NOT APPLE)
        set (CMAKE_POSITION_INDEPENDENT_CODE TRUE)
    endif()

    # For config.h, detect the libraries, functions, etc.
    include (CheckIncludeFiles)
    include (CheckLibraryExists)
    include (CheckFunctionExists)
    include (CheckTypeSize)
    include (CheckIncludeFileCXX)
    include (CheckSymbolExists)
    include (CheckCSourceCompiles)
    include (FindPkgConfig)

    check_include_file_cxx (istream HAVE_ISTREAM)
    check_include_file_cxx (ostream HAVE_OSTREAM)
    check_include_file_cxx (sstream HAVE_SSTREAM)

    check_include_files (inttypes.h HAVE_INTTYPES_H)
    check_include_files (locale.h HAVE_LOCALE_H)
    check_include_files (memory.h HAVE_MEMORY_H)
    check_include_files (stdlib.h HAVE_STDLIB_H)
    check_include_files (strings.h HAVE_STRINGS_H)
    check_include_files (string.h HAVE_STRING_H)
    check_include_files (sys/select.h HAVE_SYS_SELECT_H)
    check_include_files (sys/socket.h HAVE_SYS_SOCKET_H)
    check_include_files (sys/stat.h HAVE_SYS_STAT_H)
    check_include_files (sys/time.h HAVE_SYS_TIME_H)
    check_include_files (sys/utsname.h HAVE_SYS_UTSNAME_H)
    check_include_files (unistd.h HAVE_UNISTD_H)
    check_include_files (wchar.h HAVE_WCHAR_H)

    check_function_exists (getpwuid_r HAVE_GETPWUID_R)
    check_function_exists (gmtime_r HAVE_GMTIME_R)
    check_function_exists (nanosleep HAVE_NANOSLEEP)
    check_function_exists (poll HAVE_POLL)
    check_function_exists (sigwait HAVE_POSIX_SIGWAIT)
    check_function_exists (strftime HAVE_STRFTIME)
    check_function_exists (inet_aton HAVE_INET_ATON)

    # For some reason, the check_function_exists macro doesn't detect
    # the inet_aton on some pure Unix platforms (e.g. sunos5). So we
    # need to do a more detailed check and also include some extra libs.
    if (NOT HAVE_INET_ATON)
        set (CMAKE_REQUIRED_LIBRARIES nsl)

        check_c_source_compiles (
            "#include <arpa/inet.h>\n int main() { inet_aton (0, 0); }"
            HAVE_INET_ATON_ADV)

        set (CMAKE_REQUIRED_LIBRARIES)

        if (HAVE_INET_ATON_ADV)
            # Override the previous fail.
            set (HAVE_INET_ATON 1)

            # Assume that both nsl and socket will be needed,
            # it seems safe to add socket on the back of nsl,
            # since socket only ever needed when nsl is needed.
            list (APPEND libs nsl socket)
        endif()

    endif()

    check_type_size (char SIZEOF_CHAR)
    check_type_size (int SIZEOF_INT)
    check_type_size (long SIZEOF_LONG)
    check_type_size (short SIZEOF_SHORT)

    # pthread is used on both Linux and Mac
    set (CMAKE_THREAD_PREFER_PTHREAD TRUE)
    set (THREADS_PREFER_PTHREAD_FLAG TRUE)
    find_package (Threads REQUIRED)
    list (APPEND libs Threads::Threads)

    # curl is used on both Linux and Mac
    find_package (CURL)
    if (CURL_FOUND)
        include_directories(${CURL_INCLUDE_DIRS})
        list (APPEND libs ${CURL_LIBRARIES})

    else()
        message (FATAL_ERROR "Missing library: curl")
    endif()

    if (APPLE)
        set (CMAKE_CXX_FLAGS "--sysroot ${CMAKE_OSX_SYSROOT} ${CMAKE_CXX_FLAGS} -DGTEST_USE_OWN_TR1_TUPLE=1")

        find_library (lib_ScreenSaver ScreenSaver)
        find_library (lib_IOKit IOKit)
        find_library (lib_ApplicationServices ApplicationServices)
        find_library (lib_Foundation Foundation)
        find_library (lib_Carbon Carbon)

        list (APPEND libs
            ${lib_ScreenSaver}
            ${lib_IOKit}
            ${lib_ApplicationServices}
            ${lib_Foundation}
            ${lib_Carbon}
        )

    else() # not-apple
        # FreeBSD uses /usr/local for anything not part of base
        # Also package avahi-libdns puts dns_sd.h a bit deeper
        if (${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
            set (CMAKE_REQUIRED_INCLUDES "${CMAKE_REQUIRED_INCLUDES};/usr/local/include;/usr/local/include/avahi-compat-libdns_sd")
            set (CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -L/usr/local/lib")
            include_directories("/usr/local/include" "/usr/local/include/avahi-compat-libdns_sd")
            link_directories("/usr/local/lib")
        endif()

        if (${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")
            set (CMAKE_REQUIRED_INCLUDES "${CMAKE_REQUIRED_INCLUDES};/usr/X11R6/include;/usr/local/include;/usr/local/include/avahi-compat-libdns_sd")
            set (CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -L/usr/local/lib -L/usr/X11R6/lib")
            include_directories("/usr/local/include" "/usr/X11R6/include" "/usr/local/include/avahi-compat-libdns_sd")
            link_directories("/usr/local/lib")
            link_directories("/usr/X11R6/lib")
        endif()

        if (BARRIER_BUILD_GUI AND ${PKG_CONFIG_FOUND})
            pkg_check_modules (AVAHI_COMPAT REQUIRED avahi-compat-libdns_sd)
            include_directories (BEFORE SYSTEM ${AVAHI_COMPAT_INCLUDE_DIRS})
            set (CMAKE_REQUIRED_INCLUDES "${CMAKE_REQUIRED_INCLUDES};${AVAHI_COMPAT_INCLUDE_DIRS}")
        endif ()

        set (XKBlib "X11/Xlib.h;X11/XKBlib.h")
        set (CMAKE_EXTRA_INCLUDE_FILES "${XKBlib};X11/extensions/Xrandr.h")
        check_type_size ("XRRNotifyEvent" X11_EXTENSIONS_XRANDR_H)
        set (HAVE_X11_EXTENSIONS_XRANDR_H "${X11_EXTENSIONS_XRANDR_H}")
        set (CMAKE_EXTRA_INCLUDE_FILES)

        check_include_files ("${XKBlib};X11/extensions/dpms.h" HAVE_X11_EXTENSIONS_DPMS_H)
        check_include_files ("X11/extensions/Xinerama.h" HAVE_X11_EXTENSIONS_XINERAMA_H)
        check_include_files ("${XKBlib};X11/extensions/XKBstr.h" HAVE_X11_EXTENSIONS_XKBSTR_H)
        check_include_files ("X11/extensions/XKB.h" HAVE_XKB_EXTENSION)
        check_include_files ("X11/extensions/XTest.h" HAVE_X11_EXTENSIONS_XTEST_H)
        check_include_files ("${XKBlib}" HAVE_X11_XKBLIB_H)
        check_include_files ("X11/extensions/XInput2.h" HAVE_XI2)
        check_include_files ("dns_sd.h" HAVE_DNSSD)

        if (NOT HAVE_X11_EXTENSIONS_XTEST_H)
            message (FATAL_ERROR "Missing header: X11/extensions/XTest.h")
        endif()

        if (NOT HAVE_X11_XKBLIB_H)
            message (FATAL_ERROR "Missing header: " ${XKBlib})
        endif()

        if (BARRIER_BUILD_GUI AND NOT HAVE_DNSSD)
            message (FATAL_ERROR "Missing header: dns_sd.h")
        endif()

        check_library_exists ("SM;ICE" IceConnectionNumber "" HAVE_ICE)
        check_library_exists ("Xext;X11" DPMSQueryExtension "" HAVE_Xext)
        check_library_exists ("Xtst;Xext;X11" XTestQueryExtension "" HAVE_Xtst)
        check_library_exists ("Xinerama" XineramaQueryExtension "" HAVE_Xinerama)
        check_library_exists ("Xi" XISelectEvents "" HAVE_Xi)
        check_library_exists ("Xrandr" XRRQueryExtension "" HAVE_Xrandr)

        if (HAVE_ICE)

            # Assume we have SM if we have ICE.
            set (HAVE_SM 1)
            list (APPEND libs SM ICE)

        endif()

        if (HAVE_Xtst)

            # Xtxt depends on X11.
            set (HAVE_X11 1)
            list (APPEND libs Xtst X11)

        else()

            message (FATAL_ERROR "Missing library: Xtst")

        endif()

        if (HAVE_Xext)
            list (APPEND libs Xext)
        endif()

        if (HAVE_Xinerama)
            list (APPEND libs Xinerama)
        else (HAVE_Xinerama)
            if (HAVE_X11_EXTENSIONS_XINERAMA_H)
                set (HAVE_X11_EXTENSIONS_XINERAMA_H 0)
                message (WARNING "Old Xinerama implementation detected, disabled")
            endif()
        endif()

        if (HAVE_Xrandr)
            list (APPEND libs Xrandr)
        endif()

        # this was outside of the linux scope,
        # not sure why, moving it back inside.
        if (HAVE_Xi)
            list (APPEND libs Xi)
        endif()

    endif()

    # For config.h, set some static values; it may be a good idea to make
    # these values dynamic for non-standard UNIX compilers.
    set (ACCEPT_TYPE_ARG3 socklen_t)
    set (HAVE_CXX_BOOL 1)
    set (HAVE_CXX_CASTS 1)
    set (HAVE_CXX_EXCEPTIONS 1)
    set (HAVE_CXX_MUTABLE 1)
    set (HAVE_CXX_STDLIB 1)
    set (SELECT_TYPE_ARG1 int)
    set (SELECT_TYPE_ARG234 " (fd_set *)")
    set (SELECT_TYPE_ARG5 " (struct timeval *)")
    set (STDC_HEADERS 1)
    set (TIME_WITH_SYS_TIME 1)
    set (HAVE_SOCKLEN_T 1)

    # For config.h, save the results based on a template (config.h.in).
    configure_file (res/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/src/lib/config.h)

    add_definitions (-DSYSAPI_UNIX=1 -DHAVE_CONFIG_H)

    if (APPLE)
        add_definitions (-DWINAPI_CARBON=1 -D_THREAD_SAFE)
    else()
        add_definitions (-DWINAPI_XWINDOWS=1)
    endif()

elseif (${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /D _BIND_TO_CURRENT_VCLIBS_VERSION=1")
    set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MD /O2 /Ob2")

    list (APPEND libs Wtsapi32 Userenv Wininet comsuppw Shlwapi)

    add_definitions (
        /DSYSAPI_WIN32=1
        /DWINAPI_MSWINDOWS=1
        /D_SILENCE_TR1_NAMESPACE_DEPRECATION_WARNING=1  # tr1 is used from gtest and gmock
        /DWIN32
        /D_WINDOWS
        /D_CRT_SECURE_NO_WARNINGS
        /DBARRIER_VERSION=\"${BARRIER_VERSION}\"
        /D_XKEYCHECK_H
    )
endif()

include_directories("${CMAKE_SOURCE_DIR}/ext/gulrak-filesystem/include")

#
# OpenSSL
#
if (${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    set (OPENSSL_ROOT ${CMAKE_CURRENT_SOURCE_DIR}/ext/openssl/windows)
    if (CMAKE_SIZEOF_VOID_P EQUAL 8)
        set (OPENSSL_ROOT "${OPENSSL_ROOT}/x64")
    else()
        set (OPENSSL_ROOT "${OPENSSL_ROOT}/x86")
    endif()

    include_directories (BEFORE SYSTEM ${OPENSSL_ROOT}/include)
    set (OPENSSL_LIBS
        ${OPENSSL_ROOT}/lib/libeay32.lib
        ${OPENSSL_ROOT}/lib/ssleay32.lib
    )
elseif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    find_program(APT_PROGRAM "apt")
    find_program(BREW_PROGRAM "brew")
    find_program(PORT_PROGRAM "port")

    if (IS_DIRECTORY /opt/procursus AND APT_PROGRAM)
        # procursus/apt
        set (OPENSSL_ROOT /opt/procursus)

=== 3rdparty/quazip/CMakeLists.txt ===
﻿cmake_minimum_required(VERSION 3.13)

project(QuaZip)

# CMP0042: Explicitly acknowledge MACOSX_RPATH
# (introduced in CMake 2.8.12, enabled by default in CMake 3.0,
# and producing a warning when unset since 3.7.1)
cmake_policy(SET CMP0042 NEW)

option(BUILD_WITH_QT4 "Build QuaZip with Qt4 no matter if Qt5 was found" OFF)

if( NOT BUILD_WITH_QT4 )
    # try Qt5 first, and prefer that if found
    find_package(Qt5Core QUIET)
endif()

if(Qt5Core_FOUND)
    set(CMAKE_CXX_STANDARD 11)
    set(QTCORE_LIBRARIES ${Qt5Core_LIBRARIES})
    set(QUAZIP_LIB_VERSION_SUFFIX 5)
    # if there is no QT_ROOT, try to deduce it from Qt QtCore include
    if("${QT_ROOT}" STREQUAL "")
        set(QT_ROOT ${QT_QTCORE_INCLUDE_DIR}/../..)
    endif()
    include_directories(${Qt5Core_INCLUDE_DIRS})

    macro(qt_wrap_cpp)
        qt5_wrap_cpp(${ARGN})
    endmacro()
else()
    set(qt_min_version "4.5.0")
    find_package(Qt4 REQUIRED)
    set(QT_USE_QTGUI false)
    include(${QT_USE_FILE})
    include_directories(${QT_INCLUDES})
    set(QTCORE_LIBRARIES ${QT_QTCORE_LIBRARY})

    macro(qt_wrap_cpp)
        qt4_wrap_cpp(${ARGN})
    endmacro()
endif()

# Use system zlib on unix and Qt ZLIB on Windows
if(UNIX OR MINGW)
    find_package(ZLIB REQUIRED)
else(UNIX OR MINGW)
    # set(ZLIB_INCLUDE_DIRS "${QT_ROOT}/src/3rdparty/zlib" CACHE STRING "Path to ZLIB headers of Qt")
    # set(ZLIB_LIBRARIES "")
    # if(NOT EXISTS "${ZLIB_INCLUDE_DIRS}/zlib.h")
    #     message("Please specify a valid zlib include dir")
    # endif(NOT EXISTS "${ZLIB_INCLUDE_DIRS}/zlib.h")
endif(UNIX OR MINGW)

# All build libraries are moved to this directory
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR})

set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)")
set(LIB_DESTINATION "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE STRING "Library directory name" FORCE)
set(QUAZIP_LIB_TARGET_NAME quazip${QUAZIP_LIB_VERSION_SUFFIX} CACHE
    INTERNAL "Target name of libquazip" FORCE)

add_subdirectory(quazip)

# install(FILES FindQuaZip.cmake RENAME FindQuaZip${QUAZIP_LIB_VERSION_SUFFIX}.cmake DESTINATION ${CMAKE_ROOT}/Modules)

=== 3rdparty/zrpc/CMakeLists.txt ===
﻿cmake_minimum_required(VERSION 3.1)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
project(zrpc)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src/include)

include(protobuf-generate)

# do not find, check system installed protobuf package
if(NOT EXISTS "${PROTOBUF_DIR}")
    find_package(Protobuf REQUIRED)
    if (${PROTOBUF_FOUND})
        message("protobuf found")
    else ()
        message(FATAL_ERROR "Cannot find Protobuf")
    endif ()

    include_directories(${Protobuf_INCLUDE_DIRS})
    set(PROTOBUF_LIB
        ${Protobuf_LIBRARY}
    )
# use the local customize protobuf package
else ()
    include_directories(${PROTOBUF_DIR}/src)
    set(PROTOBUF_LIB
        protobuf::libprotobuf
    )
endif()

FILE(GLOB SRC_FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/src/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/*/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/*/*.cpp"
    )

add_library(${PROJECT_NAME} SHARED 
    ${SRC_FILES}
)
set_target_properties(${PROJECT_NAME} PROPERTIES POSITION_INDEPENDENT_CODE ON)

target_link_libraries(${PROJECT_NAME} ${PROTOBUF_LIB} co)
add_compile_definitions(${PROJECT_NAME} EXPORT_ZRPC_API)

#install library file
install(TARGETS
    ${PROJECT_NAME}
    LIBRARY
    DESTINATION
    ${LIB_INSTALL_DIR}
)

# add_subdirectory(sample)

=== modules/sslconf/CMakeLists.txt ===
﻿cmake_minimum_required(VERSION 3.13)

project(sslconf C CXX)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set (CMAKE_CXX_STANDARD 17)

# Module subdirectory
set(BARRIER_LIB_DIR "${CMAKE_SOURCE_DIR}/3rdparty/barrier/src/lib")

if (UNIX)
    set(PLATNAME unix)
    add_definitions(-DSYSAPI_UNIX=1)
else()
    set(PLATNAME win32)
    add_definitions(-DSYSAPI_WIN32=1)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /D _BIND_TO_CURRENT_VCLIBS_VERSION=1")
    set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MD /O2 /Ob2")
endif()

# Module library
file(GLOB SOURCE_FILES
    "${BARRIER_LIB_DIR}/base/finally.h"
    "${BARRIER_LIB_DIR}/base/String.h"
    "${BARRIER_LIB_DIR}/base/String.cpp"
    "${BARRIER_LIB_DIR}/io/filesystem.h"
    "${BARRIER_LIB_DIR}/io/filesystem.cpp"
    "${BARRIER_LIB_DIR}/common/DataDirectories.h"
    "${BARRIER_LIB_DIR}/common/${PLATNAME}/*.h"
    "${BARRIER_LIB_DIR}/common/${PLATNAME}/*.cpp"
    "${BARRIER_LIB_DIR}/common/DataDirectories_static.cpp"
    "${BARRIER_LIB_DIR}/net/FingerprintData.h"
    "${BARRIER_LIB_DIR}/net/FingerprintData.cpp"
    "${BARRIER_LIB_DIR}/net/FingerprintDatabase.h"
    "${BARRIER_LIB_DIR}/net/FingerprintDatabase.cpp"
    "${BARRIER_LIB_DIR}/net/SecureUtils.h"
    "${BARRIER_LIB_DIR}/net/SecureUtils.cpp"
    "*.h"
    "*.cpp"
)

add_library(${PROJECT_NAME} STATIC ${SOURCE_FILES})
if(MSVC)
    set_target_properties(${PROJECT_NAME} PROPERTIES COMPILE_FLAGS "${PEDANTIC_COMPILE_FLAGS}")
else()
    set_target_properties(${PROJECT_NAME} PROPERTIES COMPILE_FLAGS "${PEDANTIC_COMPILE_FLAGS} -Wno-shadow")
endif()

target_include_directories(${PROJECT_NAME} PUBLIC "${BARRIER_LIB_DIR}" PUBLIC ${OPENSSL_INCLUDE_DIR})
target_link_libraries(${PROJECT_NAME} ${OPENSSL_LIBRARIES})

if(FPIC)
    set_target_properties(${PROJECT_NAME} PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif()

=== src/apps/CMakeLists.txt ===
﻿add_subdirectory(data-transfer)
add_subdirectory(dde-cooperation)

if (CMAKE_SYSTEM MATCHES "Linux")
    add_subdirectory(dde-cooperation-transfer)
endif()

# launcher
# add_subdirectory("launcher")

=== src/compat/CMakeLists.txt ===
﻿include_directories(include)
include("${CMAKE_SOURCE_DIR}/modules/compat.cmake")

set(COMPAT_ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}")
include_directories(${COMPAT_ROOT_DIR})

add_subdirectory(protocol)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

add_subdirectory(framework)
add_subdirectory(plugins)

add_subdirectory(apps)

=== 3rdparty/CppServer/modules/CMakeLists.txt ===
include("asio.cmake")
if (NOT ANDROID)
include("CppLogging.cmake")
else()
include("android-uuid.cmake")
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
endif()
include("CppCommon.cmake")
if(NOT CPPSERVER_MODULE)
    include("Catch2.cmake")
    include("cpp-optparse.cmake")
    include("CppBenchmark.cmake")
endif()

=== debian/changelog ===
dde-cooperation (1.0.2-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@linuxdeepin.com>  Fri, 22 Nov 2024 17:13:24 +0800

dde-cooperation (1.0.2) unstable; urgency=medium

  * v1.0.2 version update.
  * feat: [cast]Update QR with url
  * fix: [ui]Fix some ui layout issues
  * fix: [share]Terminate all process before start one
  * fix: [share]Make the peripheral share controlable by setting
  * fix: Fix the vnc view not change mode if mobile has changed show mode
  * fix: [memory leaks] Fix memory leaks

 -- re2zero <yangwu@uniontech.com>  Thu, 21 Nov 2024 04:55:18 +0800

dde-cooperation (1.0.1) unstable; urgency=medium

  * v1.0.1 version update.
  * fix some issues.

 -- re2zero <yangwu@uniontech.com>  Fri, 01 Nov 2024 11:52:26 +0800

dde-cooperation (0.9.2) unstable; urgency=medium

  * v0.9.2 version update.
  * fix some issues.

 -- re2zero <yangwu@uniontech.com>  Tue, 08 Oct 2024 15:08:16 +0800

dde-cooperation (0.9.1) unstable; urgency=medium

  * v0.9.1 version update.
  * fix discovery issue with old protocol version.

 -- re2zero <yangwu@uniontech.com>  Fri, 20 Sep 2024 14:16:16 +0800

dde-cooperation (0.9.0) unstable; urgency=medium

  * v0.9.0 version update.
  * added a new communication method that is compatible with previous versions.

 -- liujinchang <liujinchang@uniontech.com>  Wed, 28 Aug 2024 09:51:44  +0800

dde-cooperation (0.8.0) unstable; urgency=medium

  * v0.8.0 version update.
  * refactor structure and reimplement.

 -- re2zero <yangwu@uniontech.com>  Fri, 17 May 2024 16:46:16 +0800

=== debian/control ===
Source: dde-cooperation
Priority: optional
Maintainer: Deepin Packages Builder <packages@linuxdeepin.com>
Build-Depends:
 debhelper (>= 11),
 pkg-config,
 cmake,
 qtchooser,
 qtbase5-dev,
 qttools5-dev-tools,
 qttools5-dev,
 libqt5svg5-dev,
 libdtkwidget-dev,
 libdtkgui-dev,
 libdtkcore-dev,
 libdtkcore5-bin,
 libssl-dev,
 libzip-dev,
 libcurl4-openssl-dev,
 libxtst-dev,
 libavahi-compat-libdnssd-dev,
 libxinerama-dev,
 libxrandr-dev,
 libxrender-dev,
 libxkbcommon-dev,
 libx11-dev,
 libice-dev,
 libsm-dev,
 uuid-dev,
 libdisplayjack-dev | hello,
 libsystemd-dev,
 libqrencode-dev,
Standards-Version: 4.1.3
Section: utils
Homepage: http://www.deepin.org

Package: dde-cooperation-dev
Section: libdevel
Architecture: any
Depends: dde-cooperation (= ${binary:Version}), ${misc:Depends}
Description: Development package for deepin cooperation application
 This package contains the header files and static libraries

Package: deepin-data-transfer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: deepin data transfer application
 Deepin Desktop Environment (DDE) - data transfer application.

Package: dde-cooperation
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
 libqrencode4
Replaces:
 QtZeroConf,
 dde-cooperation-transfer (<< 1.0.0),
 dde-cooperation-daemon (<< 1.0.0),
Description: deepin cooperation application
 Deepin Desktop Environment (DDE) - cooperation application.

Package: dde-cooperation-transfer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, dde-cooperation (= ${binary:Version})
Description: deepin file delivery
 Deepin Desktop Environment (DDE) - file transfer application.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk

# 检测当前安装的Qt版本并设置QT_SELECT环境变量
define detect_qt_version
ifneq (,$(shell which qmake6 2>/dev/null))
    $(shell qtchooser -install qt6 $(shell which qmake6))
    export QT_SELECT=qt6
else
    export QT_SELECT=qt5
endif
endef

# 调用检测Qt版本的命令
$(eval $(call detect_qt_version))

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_BUILD_TYPE=Release \
	-DHOST_MULTIARCH="$(DEB_HOST_MULTIARCH)" \
	-DAPP_VERSION=$(DEB_VERSION_UPSTREAM)

## dde-cooperation 1.1.2

=== debian/changelog ===
dde-cooperation (1.1.2) unstable; urgency=medium

  * v1.1.2 version update.
  * fix: Fix crash issue after network change.

 -- re2zero <yangwu@uniontech.com>  Tue, 29 Apr 2025 19:21:18 +0800

dde-cooperation (1.1.1) unstable; urgency=medium

  * v1.1.1 version update.
  * fix: Fix miss the dynamic library issue.

 -- re2zero <yangwu@uniontech.com>  Fri, 25 Apr 2025 15:55:10 +0800

dde-cooperation (1.1.0) unstable; urgency=medium

  * v1.1.0 version update.
  * feat: refactoring code structure.

 -- re2zero <yangwu@uniontech.com>  Thu, 24 Apr 2025 19:55:10 +0800

dde-cooperation (1.0.12) unstable; urgency=medium

  * v1.0.12 version update.
  * feat: Remove displayjack kvm depend.

 -- re2zero <yangwu@uniontech.com>  Thu, 27 Mar 2025 13:25:42 +0800

dde-cooperation (1.0.11) unstable; urgency=medium

  * v1.0.11 version update.

 -- re2zero <yangwu@uniontech.com>  Thu, 20 Mar 2025 18:55:55 +0800

dde-cooperation (1.0.10) unstable; urgency=medium

  * v1.0.10 version update.
  * Fix work with compat target issue.
  * Fix close dialog not show in center.
  * fix: Fix incorrect default setting.
  * fix: Fix dialog does not show in center.
  * fix: Fix notification do not update issue.

 -- re2zero <yangwu@uniontech.com>  Thu, 20 Feb 2025 19:33:13 +0800

dde-cooperation (1.0.9) unstable; urgency=medium

  * v1.0.9 version update.
  * fix: fix CI build issue.

 -- re2zero <yangwu@uniontech.com>  Mon, 20 Jan 2025 17:30:43 +0800

dde-cooperation (1.0.8) unstable; urgency=medium

  * v1.0.8 version update.
  * [ipc]Enable Qt6 support.
  * fix: Workaround notification incorrect issue.
  * Fix light style issue.
  * [vnc]Fix display incorrect image issue.

 -- re2zero <yangwu@uniontech.com>  Mon, 20 Jan 2025 15:30:43 +0800

dde-cooperation (1.0.7) unstable; urgency=medium

  * v1.0.7 version update.

 -- re2zero <yangwu@uniontech.com>  Thu, 2 Jan 2025 02:57:05 +0800

dde-cooperation (1.0.6) unstable; urgency=medium

  * v1.0.6 version update.
  * fix: Fix resource release
  * fix: [dt]Disable compat for datatransfer
  * fix: Fix memory leak

 -- re2zero <yangwu@uniontech.com>  Thu, 26 Dec 2024 02:57:05 +0800

dde-cooperation (1.0.5) unstable; urgency=medium

  * v1.0.5 version update.
  * chore: [ci]Change msvc action
  * chore: Change depending
  * fix: Fix file transfer was freezed
  * feat: Add download link

 -- re2zero <yangwu@uniontech.com>  Sat, 14 Dec 2024 04:28:55 +0800

dde-cooperation (1.0.4) unstable; urgency=medium

  * v1.0.4 version update.
  * fix: Fix it still continue cooperation even has been canceled
  * chore: Rename daemon backend and remove unused codes
  * fix: Fix incorrect status issue
  * feat: [plugin]Move the file deliver plugin from extension project
  * fix: Fix file delivery and single app show issue

 -- re2zero <yangwu@uniontech.com>  Sat, 07 Dec 2024 11:19:12 +0800

dde-cooperation (1.0.3) unstable; urgency=medium

  * v1.0.3 version update.
  * fix: [ui]workaround crash on treeland.
  * refactor: [compat]Add macro define for compatibile mode

 -- re2zero <yangwu@uniontech.com>  Sat, 30 Nov 2024 01:16:56 +0800
